(function ($, Drupal, drupalSettings) {

  // This overrides the default click handler on the solution button.
  Drupal.behaviors.crosswordContest = {
    attach: function (context, settings) {
      var selector = drupalSettings.crossword.selector;
      $(selector).once('crossword-contest-init').each(function () {
        var $crossword = $(this);
        var Crossword = $crossword.data("Crossword");

        $('.button-solution', $crossword).once('crossword-submit-click').off('click').click(function(e){
          e.preventDefault();
          if ($(this).data('confirm')) {
            var message = $(this).data('confirm');
            if (!confirm(message)) {
              return;
            }
          }
          var answer_for_url = encodeURIComponent(JSON.stringify(Crossword.getAnswers()));
          var mid = drupalSettings.crossword.mid;
          var url = 'crossword-contest/' + mid + '/' + answer_for_url;
          var submit = Drupal.ajax({
            url: Drupal.url(url),
          });
          submit.execute();
        });
      });
    },
  }
})(jQuery, Drupal, drupalSettings);
